#include <wx/glcanvas.h>
#include <wx/dcclient.h>
#include <wx/dcbuffer.h>
#include <wx/dialog.h>
#include <wx/image.h>
#include <string.h>
#include "defs.h"
//#include "OscFont.h"

#define GRID_AREA 100.0f // how big grid area is
#define GRID_NO_OF_X 17.0f // how many grid bags are there in the grid
#define GRID_NO_OF_Y 16.0f // how many grid bags are there in the grid
#define GRID_FLOAT 2.0f // how much space is there before the end and the start of wxglcanvas
#define GRID_TRA ((double)(GRID_AREA/GRID_NO_OF_X)) // how many grid bags are there in the grid
#define GRID_TRAH ((double)(GRID_TRA/2.0f)) // half of the above
#define GRID_HALF ((double)(GRID_AREA/2.0f)) // half of the area
#define GRID_TRH ((double)(GRID_HALF+GRID_FLOAT)) // passed to glortho

class OscScreen : public wxGLCanvas{
private:

    float* Waveforms;
//    OscFont font;

    int CH;

    // Draws labels such as y(x) and volt/count markers to wxGL canvas
    
    // Other internal drawing related member functions
    void SetUpGL();
    void RenderBackground();
    void RenderSignal();
     

public:
    OscScreen(wxWindow *parent, wxWindowID id, const wxPoint &pos, const wxSize &size);
    ~OscScreen();

    void DrawLabels(float voltage = 1.0f);

    void SetWaveforms(float *buffer);
	float* GetWaveforms(void);
	
    wxImage* readPixels(void); // Reads pixel data to wxImage from OpenGL canvas.
    void Render();

    void SetSize(wxSize size);

    void OnPaint(wxPaintEvent &event);
    void OnSize(wxSizeEvent &event);

    void SetCH(int ch);

    DECLARE_EVENT_TABLE()
};
