//---------------------------------------------------------------------------
//
// Name:        PSEC3_evalFrm.cpp
// Author:      Andrew Wong
// Created:     2/6/2008 4:51:21 PM
// Description: PSEC3_evalFrm class implementation
//
//---------------------------------------------------------------------------

#include "PSEC3_evalFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// PSEC3_evalFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(PSEC3_evalFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(PSEC3_evalFrm::OnClose)
	EVT_BUTTON(ID_BTNSAVESPIKEHISTOGRAM,PSEC3_evalFrm::btnSaveSpikeHistogramClick)
	EVT_BUTTON(ID_BTNSINGLEEVENT,PSEC3_evalFrm::btnSingleEventClick)
	EVT_TOGGLEBUTTON(ID_BTNREADDATA,PSEC3_evalFrm::btnReadDataClick)
	EVT_BUTTON(ID_BTNINIT,PSEC3_evalFrm::btnInitClick)
	EVT_SPINCTRL(ID_SPINTRIGGERVOLTAGE,PSEC3_evalFrm::spinTriggerVoltageUpdated)
	EVT_BUTTON(ID_BTNSAVEPEDESTAL,PSEC3_evalFrm::btnSavePedestalClick)
	EVT_BUTTON(ID_BTNLOADPEDESTAL,PSEC3_evalFrm::btnLoadPedestalClick)
	EVT_BUTTON(ID_BTNSETPEDVOLTAGE,PSEC3_evalFrm::btnSetPedVoltageClick)
	EVT_SPINCTRL(ID_SPINPEDVOLTAGE,PSEC3_evalFrm::spinPedVoltageUpdated)
	EVT_BUTTON(ID_BTNLOADLUT,PSEC3_evalFrm::btnLoadLUTClick)
	EVT_LISTBOX(ID_BOXACTIVECHANNEL,PSEC3_evalFrm::boxActiveChannelSelected)
	EVT_TOGGLEBUTTON(ID_BTNLOGDATA,PSEC3_evalFrm::btnLogDataClick)
	EVT_BUTTON(ID_BTNCREATELUT,PSEC3_evalFrm::btnCreateLutClick)
	EVT_BUTTON(ID_BTNCREATEPEDESTAL,PSEC3_evalFrm::btnCreatePedestalClick)
	EVT_TOGGLEBUTTON(ID_BTNSYNCUSB,PSEC3_evalFrm::btnSyncUSBClick)
END_EVENT_TABLE()
////Event Table End

PSEC3_evalFrm::PSEC3_evalFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

PSEC3_evalFrm::~PSEC3_evalFrm()
{
}

void PSEC3_evalFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0, 0), wxSize(649, 558));

	boxDisplay = new wxNotebook(WxPanel1, ID_BOXDISPLAY, wxPoint(0, 0), wxSize(640, 400), wxNB_DEFAULT);

	pageGraph = new wxPanel(boxDisplay, ID_PAGEGRAPH, wxPoint(4, 24), wxSize(632, 372));
	boxDisplay->AddPage(pageGraph, wxT("Graph"));

	pageOutput = new wxPanel(boxDisplay, ID_PAGEOUTPUT, wxPoint(4, 24), wxSize(632, 372));
	boxDisplay->AddPage(pageOutput, wxT("Raw Output"));

	rawOutput = new wxTextCtrl(pageOutput, ID_RAWOUTPUT, wxEmptyString, wxPoint(0, 0), wxSize(631, 372), wxTE_MULTILINE, wxDefaultValidator, wxT("rawOutput"));
	rawOutput->SetMaxLength(0);
	rawOutput->AppendText(wxT("rawOutput"));
	rawOutput->SetFocus();
	rawOutput->SetInsertionPointEnd();

	grpInit = new wxStaticBox(WxPanel1, ID_GRPINIT, wxT("Init settings"), wxPoint(140, 494), wxSize(457, 50));

	btnSyncUSB = new wxToggleButton(WxPanel1, ID_BTNSYNCUSB, wxT("SYNC_USB"), wxPoint(554, 406), wxSize(88, 25), 0, wxDefaultValidator, wxT("btnSyncUSB"));

	btnCreatePedestal = new wxButton(WxPanel1, ID_BTNCREATEPEDESTAL, wxT("Create Pedestal"), wxPoint(194, 408), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnCreatePedestal"));

	btnCreateLut = new wxButton(WxPanel1, ID_BTNCREATELUT, wxT("Create LUT"), wxPoint(307, 408), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnCreateLut"));

	btnLogData = new wxToggleButton(WxPanel1, ID_BTNLOGDATA, wxT("Log Data"), wxPoint(445, 409), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLogData"));

	wxArrayString arrayStringFor_boxSamplingSpeed;
	arrayStringFor_boxSamplingSpeed.Add(wxT("10 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("2.6 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("5.1 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("15.4 GSa/s"));
	boxSamplingSpeed = new wxComboBox(WxPanel1, ID_BOXSAMPLINGSPEED, wxT("10 GSa/s"), wxPoint(146, 511), wxSize(77, 21), arrayStringFor_boxSamplingSpeed, wxCB_READONLY, wxDefaultValidator, wxT("boxSamplingSpeed"));

	wxArrayString arrayStringFor_boxActiveChannel;
	boxActiveChannel = new wxListBox(WxPanel1, ID_BOXACTIVECHANNEL, wxPoint(118, 408), wxSize(72, 67), arrayStringFor_boxActiveChannel, wxLB_SINGLE);
	boxActiveChannel->Append(wxT("CH1"));
	boxActiveChannel->Append(wxT("CH2"));
	boxActiveChannel->Append(wxT("CH3"));
	boxActiveChannel->Append(wxT("CH4"));

	btnLoadLUT = new wxButton(WxPanel1, ID_BTNLOADLUT, wxT("Load LUT"), wxPoint(307, 433), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLoadLUT"));

	spinPedVoltage = new wxSpinCtrl(WxPanel1, ID_SPINPEDVOLTAGE, wxT("2048"), wxPoint(296, 470), wxSize(63, 22), wxSP_ARROW_KEYS, 0, 4096, 2048);

	btnSetPedVoltage = new wxButton(WxPanel1, ID_BTNSETPEDVOLTAGE, wxT("Set Ped Voltage"), wxPoint(451, 470), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnSetPedVoltage"));

	txtPedVoltage = new wxStaticText(WxPanel1, ID_TXTPEDVOLTAGE, wxT("? V"), wxPoint(369, 474), wxDefaultSize, 0, wxT("txtPedVoltage"));

	btnLoadPedestal = new wxButton(WxPanel1, ID_BTNLOADPEDESTAL, wxT("Load Pedestal"), wxPoint(197, 430), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLoadPedestal"));

	btnSavePedestal = new wxButton(WxPanel1, ID_BTNSAVEPEDESTAL, wxT("Save Pedestal"), wxPoint(197, 456), wxSize(98, 25), 0, wxDefaultValidator, wxT("btnSavePedestal"));

	wxArrayString arrayStringFor_boxTriggerSign;
	arrayStringFor_boxTriggerSign.Add(wxT("external, -"));
	arrayStringFor_boxTriggerSign.Add(wxT("external, +"));
	arrayStringFor_boxTriggerSign.Add(wxT("internal, -"));
	arrayStringFor_boxTriggerSign.Add(wxT("internal, +"));
	boxTriggerSign = new wxComboBox(WxPanel1, ID_BOXTRIGGERSIGN, wxT("external, -"), wxPoint(230, 512), wxSize(95, 21), arrayStringFor_boxTriggerSign, wxCB_READONLY, wxDefaultValidator, wxT("boxTriggerSign"));

	spinTriggerVoltage = new wxSpinCtrl(WxPanel1, ID_SPINTRIGGERVOLTAGE, wxT("0"), wxPoint(328, 511), wxSize(67, 22), wxSP_ARROW_KEYS, 0, 4095, 0);

	txtTrigThres = new wxStaticText(WxPanel1, ID_TXTTRIGTHRES, wxT("Trigger Thres: 0.81V"), wxPoint(398, 513), wxDefaultSize, 0, wxT("txtTrigThres"));

	btnInit = new wxButton(WxPanel1, ID_BTNINIT, wxT("Init"), wxPoint(513, 509), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnInit"));

	btnReadData = new wxToggleButton(WxPanel1, ID_BTNREADDATA, wxT("Read Data"), wxPoint(555, 457), wxSize(88, 25), 0, wxDefaultValidator, wxT("btnReadData"));

	btnSingleEvent = new wxButton(WxPanel1, ID_BTNSINGLEEVENT, wxT("Single Event"), wxPoint(554, 431), wxSize(89, 25), 0, wxDefaultValidator, wxT("btnSingleEvent"));

	WxStatusBar = new wxStatusBar(this, ID_WXSTATUSBAR);

	txtSpikeStats = new wxStaticText(WxPanel1, ID_TXTSPIKESTATS, wxT("Stats on spikes:"), wxPoint(1, 405), wxDefaultSize, 0, wxT("txtSpikeStats"));

	btnSaveSpikeHistogram = new wxButton(WxPanel1, ID_BTNSAVESPIKEHISTOGRAM, wxT("Save Spike Histogram"), wxPoint(4, 519), wxSize(131, 31), 0, wxDefaultValidator, wxT("btnSaveSpikeHistogram"));

	SetStatusBar(WxStatusBar);
	SetTitle(wxT("PSEC3_eval"));
	SetIcon(wxNullIcon);
	SetSize(8,8,657,611);
	Center();
	
	////GUI Items Creation End
	
	scope = new OscScreen(this->pageGraph, 0, wxPoint(0,0), wxSize(632, 372));
	
	chOffset = 2;
	boxActiveChannel->SetSelection(0);
	
	wxSpinEvent evt;
	
	spinTriggerVoltageUpdated( evt );
    spinPedVoltageUpdated( evt );
    
    // init spike stats variables
    for(int i=0; i < CHANNELS; i++)
        chSpikes[i] = 0;
        
    for(int i=0; i < BUFFERSIZE; i++)
        bufferSpikes[i] = 0;
    
    totalReadouts = 0;
    
}

void PSEC3_evalFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * btnReadDataClick
 */
void PSEC3_evalFrm::btnReadDataClick(wxCommandEvent& event)
{
    do {
        if (! btnSyncUSB->GetValue() ) {
            in.createHandles();
            in.sendData(0x2);
            in.freeHandles();   
        }
        ReadData();
        wxYield();
    } while (btnReadData->GetValue() );

    
}

void PSEC3_evalFrm::ReadData() {
    int readoutsize = 1300;
    int read;

	in.createHandles();
    in.readData(this->buffer, readoutsize, &read);
	in.freeHandles();

    this->rawOutput->Clear();
    
    wxString rawText, numText;
    
    if (read > readoutsize) {
        rawText = numText = wxString::Format("Readout error - got %d bytes", read);        
    }
    else {
        rawText = numText = wxString::Format("Read %d bytes\n", read);

        rawText.Alloc(read * 7);
        
        for(int i=0; i < read; i++) {
            rawText += wxString::Format("%04x, ", buffer[i]);
            wxYield();
        }
}
    
    this->rawOutput->AppendText(rawText);

    bool hasSpike = false;
    for(int i=DATA_OFFSET; i < DATA_OFFSET+CHANNELS*CH_BUFFERSIZE; i++) {
        if ((buffer[i] & 0xf000) || (LUT[buffer[i] ][(i-DATA_OFFSET)/CH_BUFFERSIZE] < 0)) {
            bufferSpikes[i]++;
//            hasSpike = true;
            chSpikes[(i-DATA_OFFSET)/CH_BUFFERSIZE]++;
        }   
    }
    totalReadouts++;

    UpdateWaveforms();	
    LogData();    
    UpdateSpikeStats();
}

void PSEC3_evalFrm::UpdateWaveforms() {
    int ch = boxActiveChannel->GetSelection();

    wxString data = "";
    for(int i=chOffset, j=0; j < CH_BUFFERSIZE; j++,i++) {
        float pedValue, signalValue;
        if (buffer[i] < MAX_LUT && LUT[buffer[i] ][ch] >=0 ) {
            signalValue = LUT[buffer[i] ][ch];
            pedValue = LUT[ activePedestal[ch*CH_BUFFERSIZE + j] ][ch];
            Waveform[j] = (float)(signalValue - pedValue) * 50;
        } else {
//            signalValue = LUT[ activePedestal[ch*CH_BUFFERSIZE + j] ][ch];
//                signalValue = 1.0;  // max value to represent overflow 'spike'
//            wxMessageBox(wxString::Format("Out of bound value: %d", buffer[i] ) );
            Waveform[j] = 50.0;
//            wxMessageBox("test");
        }
                                                            // x50 to accommodate oscilloscope display
//        data += wxString::Format("%f, ", Waveform[j]/50.0 );
    }

//    rawOutput->AppendText("Display: " + data);

    this->scope->SetWaveforms(Waveform);
    scope->Render();
       
}

/*
 * boxActiveChannelSelected
 */
void PSEC3_evalFrm::boxActiveChannelSelected(wxCommandEvent& event)
{
    int val = boxActiveChannel->GetSelection();
    
    chOffset = val * CH_BUFFERSIZE + DATA_OFFSET;
    
    UpdateWaveforms();
}

/*
 * btnCreatePedestalClick
 */
void PSEC3_evalFrm::btnCreatePedestalClick(wxCommandEvent& event)
{
    CreatePedestal();	
}

void PSEC3_evalFrm::CreatePedestal(int pedVoltage)
{
    
    in.createHandles();
    
    if (pedVoltage != -1) {
        unsigned int cmd = (pedVoltage << 16) | 0x3;
        in.sendData(cmd);
    }    
    
    wxMilliSleep(2000);                     // wait?

    
    const int PEDESTAL_ITERATIONS = 400;
    
    int pedValue[DATASIZE][PEDESTAL_ITERATIONS];
    
    for(int i=0; i < PEDESTAL_ITERATIONS; i++) {
        in.sendData(0x2);                   // trigger
        
        unsigned short buffer[1300];
        
        int count;
        in.readData(buffer, 1300, &count);
        
        if (count < BUFFERSIZE) {
            i--;
            continue;   
        }
        
        for(int j=0; j < DATASIZE; j++)
            pedValue[j][i] = buffer[j+DATA_OFFSET];
            
        WxStatusBar->SetStatusText(wxString::Format("%d: Pedestal readout %d of %d", pedVoltage, i, PEDESTAL_ITERATIONS));
        wxYield();
    }
 
    
    for(int i=0; i < DATASIZE; i++) {
        sort(pedValue[i], pedValue[i]+PEDESTAL_ITERATIONS );
                        
        activePedestal[i] = pedValue[i][PEDESTAL_ITERATIONS/2];
    }

    in.freeHandles();
}

/*
 * btnCreateLutClick
 */
void PSEC3_evalFrm::btnCreateLutClick(wxCommandEvent& event)
{
    for(int i=0; i < 4096; i++)
        LUT[i][0] = LUT[i][1] = LUT[i][2] = LUT[i][3] =  -1;

    for(int i=10; i < 3511; i+=20) { 
        CreatePedestal(i);
        
        float voltage = i * 1.200/4096.0;
        
        for(int j=0; j < CHANNELS; j++) {
            int average = 0;
            
            for(int k=0; k < CH_BUFFERSIZE; k++)
                average += activePedestal[k+j*CH_BUFFERSIZE];
                
            average /= CH_BUFFERSIZE;    
            
            if (average > 0 && average < 4096)
                LUT[average][j] = voltage;
        }
    }

    // do interpolations
    int first, second, j;
    for(int i=0; i < 4; i++) {  // for each channel
        // find first value
        for(j=0; LUT[j][i] < 0; j++);  // don't test equality with floating point #s
        
        first = j;  // first is now the first LUT value
        
        while (j < 4096) {
            for(j++; LUT[j][i] < 0 && j < 4096; j++);
            
            if (j >= 4096) continue;
            
            second = j;
            
            for(int k=first+1; k < second; k++) {
                LUT[k][i] = LUT[first][i] + (float)(k-first)/(second-first) * (LUT[second][i] - LUT[first][i] );
            }

            first = second;
        }
        
        
        
    }

    FILE* fout = fopen("LUT.txt", "w");
    for(int i=0; i < 4096; i++)
        fprintf(fout, "%d\t%f\t%f\t%f\t%f\t\n", i, LUT[i][0], LUT[i][1], LUT[i][2], LUT[i][3] );
    
    fclose(fout);
}

/*
 * btnLoadLUTClick
 */
void PSEC3_evalFrm::btnLoadLUTClick(wxCommandEvent& event)
{
    FILE* fout = fopen("LUT.txt", "r");
    while (!feof(fout)) {
        int i;
        fscanf(fout, "%d\t", &i);
        
        if (feof(fout)) continue;
        
        fscanf(fout, "%f\t%f\t%f\t%f\t\n", &LUT[i][0], &LUT[i][1], &LUT[i][2], &LUT[i][3] );
    }

    fclose(fout);
}

/*
 * btnSetPedVoltageClick
 */
void PSEC3_evalFrm::btnSetPedVoltageClick(wxCommandEvent& event)
{
	int val = spinPedVoltage->GetValue();
	
	in.createHandles();
	in.sendData(val << 16 | 0x3);
	in.freeHandles();
}

/*
 * spinPedVoltageUpdated
 */
void PSEC3_evalFrm::spinPedVoltageUpdated(wxSpinEvent& WXUNUSED(event) )
{
	int val = spinPedVoltage->GetValue();
	
	float voltage = val * 1.2/4096;
	txtPedVoltage->SetLabel(wxString::Format("%f V", voltage) );
}

/*
 * btnSavePedestalClick
 */
void PSEC3_evalFrm::btnSavePedestalClick(wxCommandEvent& event)
{
	FILE* fout = fopen("pedestal.txt", "w");
	
	for(int i=0; i < DATASIZE; i++)
	   fprintf(fout, "%d\n", activePedestal[i]);
	   
	fclose(fout);
}

/*
 * spinTriggerVoltageUpdated
 */
void PSEC3_evalFrm::spinTriggerVoltageUpdated(wxSpinEvent& WXUNUSED(event) )
{
	int val = spinTriggerVoltage->GetValue();
	
	float voltage = (float)val*1.2/4096;
	
	txtTrigThres->SetLabel(wxString::Format("Trigger Thres: %.2fV", voltage));
}

/*
 * btnInitClick
 */
void PSEC3_evalFrm::btnInitClick(wxCommandEvent& event)
{
	int thres, sign, samp;
	
	samp = boxSamplingSpeed->GetSelection();
	sign = boxTriggerSign->GetSelection();
	thres = spinTriggerVoltage->GetValue();
	
	unsigned int cmd = (samp << 30) | (sign << 28) | (thres << 16) | 0xff;
	
	in.createHandles();
    in.sendData(cmd);
    in.freeHandles();
}

/*
 * btnSingleEventClick
 */
void PSEC3_evalFrm::btnSingleEventClick(wxCommandEvent& event)
{
    in.createHandles();
    
    if (! btnSyncUSB->GetValue()) {
        in.sendData(0x2);
    }
    
    ReadData();
    
    in.freeHandles();
}

/*
 * btnSyncUSBClick
 */
void PSEC3_evalFrm::btnSyncUSBClick(wxCommandEvent& event)
{
    in.createHandles();
    if (btnSyncUSB->GetValue() )
        in.sendData(0x10001);
    else
        in.sendData(0x00001);
        
    in.freeHandles();
}

/*
 * btnLoadPedestalClick
 */
void PSEC3_evalFrm::btnLoadPedestalClick(wxCommandEvent& event)
{
	FILE* fout = fopen("pedestal.txt", "r");
	
	for(int i=0; i < DATASIZE; i++)
	   fscanf(fout, "%d\n", &activePedestal[i]);
	   
	fclose(fout);
}

/*
 * btnLogDataClick
 */
void PSEC3_evalFrm::btnLogDataClick(wxCommandEvent& event)
{
	if (btnLogData->GetValue()) {
        logFile = fopen("logfile.txt", "w");
    }
    else {
        fclose(logFile);
        logFile = NULL;
    }
}

void PSEC3_evalFrm::LogData() {
    if (btnLogData->GetValue() == false)
        return;
        
    for(int i=2; i < 1026; i++)
        fprintf(logFile, "%d\n", buffer[i]);
    
    fprintf(logFile, "\n");
    
}

void PSEC3_evalFrm::UpdateSpikeStats() {
    wxString result = "";
    
    result += wxString::Format("Total readouts: %d\nCH1: %d\nCH2: %d\nCH3: %d\nCH4: %d", totalReadouts, chSpikes[0], 
        chSpikes[1], chSpikes[2], chSpikes[3]);
    
    txtSpikeStats->SetLabel(result);
    
    
}

/*
 * btnSaveSpikeHistogramClick
 */
void PSEC3_evalFrm::btnSaveSpikeHistogramClick(wxCommandEvent& event)
{
    FILE* fout = fopen("spikehist.txt", "w");
    
    for(int i=0; i < CHANNELS; i++)
        for(int j=0; j < CH_BUFFERSIZE; j++)
            fprintf(fout, "%d\n", bufferSpikes[DATA_OFFSET + j + i*CH_BUFFERSIZE] );

    fclose(fout);
}
