//---------------------------------------------------------------------------
//
// Name:        PSEC3_evalFrm.h
// Author:      Andrew Wong
// Created:     2/6/2008 4:51:21 PM
// Description: PSEC3_evalFrm class declaration
//
//---------------------------------------------------------------------------

#ifndef __PSEC3_evalFRM_h__
#define __PSEC3_evalFRM_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/statusbr.h>
#include <wx/stattext.h>
#include <wx/spinctrl.h>
#include <wx/listbox.h>
#include <wx/combobox.h>
#include <wx/button.h>
#include <wx/tglbtn.h>
#include <wx/statbox.h>
#include <wx/textctrl.h>
#include <wx/notebook.h>
#include <wx/panel.h>
////Header Include End

#include <vector>
#include <algorithm>
using namespace std;

#include <wx/dir.h>

#include "stdUSB.h"
#include "OscScreen.h"
#include "iniparser.h"
#include "defs.h"

////Dialog Style Start
#undef PSEC3_evalFrm_STYLE
#define PSEC3_evalFrm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class PSEC3_evalFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		PSEC3_evalFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("PSEC3_eval"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = PSEC3_evalFrm_STYLE);
		virtual ~PSEC3_evalFrm();
		void WxPanel1UpdateUI(wxUpdateUIEvent& event);
		void btnSendCommandClick(wxCommandEvent& event);
		void btnReadDataClick(wxCommandEvent& event);
		void btnFindReadoutSizeClick(wxCommandEvent& event);
		void listCommandsSelected(wxCommandEvent& event );
		void boxPresetSelected(wxCommandEvent& event );
		void btnSaveSettingsClick(wxCommandEvent& event);
		void boxActiveChannelSelected(wxCommandEvent& event);
		void btnCreatePedestalClick(wxCommandEvent& event);
		void btnCreateLutClick(wxCommandEvent& event);
		void btnLoadLUTClick(wxCommandEvent& event);
		void btnSetPedVoltageClick(wxCommandEvent& event);
		void spinPedVoltageUpdated(wxSpinEvent& event );
		void btnSavePedestalClick(wxCommandEvent& event);
		void spinTriggerVoltageUpdated(wxSpinEvent& event );
		void btnInitClick(wxCommandEvent& event);
		void btnSingleEventClick(wxCommandEvent& event);
		void btnSyncUSBClick(wxCommandEvent& event);
		void brnLoadPedestalClick(wxCommandEvent& event);
		void btnLoadPedestalClick(wxCommandEvent& event);
		void btnLogDataClick(wxCommandEvent& event);
		void btnSaveSpikeHistogramClick(wxCommandEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *btnSaveSpikeHistogram;
		wxStaticText *txtSpikeStats;
		wxStatusBar *WxStatusBar;
		wxButton *btnSingleEvent;
		wxToggleButton *btnReadData;
		wxButton *btnInit;
		wxStaticText *txtTrigThres;
		wxSpinCtrl *spinTriggerVoltage;
		wxComboBox *boxTriggerSign;
		wxButton *btnSavePedestal;
		wxButton *btnLoadPedestal;
		wxStaticText *txtPedVoltage;
		wxButton *btnSetPedVoltage;
		wxSpinCtrl *spinPedVoltage;
		wxButton *btnLoadLUT;
		wxListBox *boxActiveChannel;
		wxComboBox *boxSamplingSpeed;
		wxToggleButton *btnLogData;
		wxButton *btnCreateLut;
		wxButton *btnCreatePedestal;
		wxToggleButton *btnSyncUSB;
		wxStaticBox *grpInit;
		wxTextCtrl *rawOutput;
		wxPanel *pageOutput;
		wxPanel *pageGraph;
		wxNotebook *boxDisplay;
		wxPanel *WxPanel1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_BTNSAVESPIKEHISTOGRAM = 1040,
			ID_TXTSPIKESTATS = 1039,
			ID_WXSTATUSBAR = 1024,
			ID_BTNSINGLEEVENT = 1038,
			ID_BTNREADDATA = 1037,
			ID_BTNINIT = 1036,
			ID_TXTTRIGTHRES = 1035,
			ID_SPINTRIGGERVOLTAGE = 1034,
			ID_BOXTRIGGERSIGN = 1032,
			ID_BTNSAVEPEDESTAL = 1031,
			ID_BTNLOADPEDESTAL = 1030,
			ID_TXTPEDVOLTAGE = 1029,
			ID_BTNSETPEDVOLTAGE = 1028,
			ID_SPINPEDVOLTAGE = 1027,
			ID_BTNLOADLUT = 1025,
			ID_BOXACTIVECHANNEL = 1023,
			ID_BOXSAMPLINGSPEED = 1022,
			ID_BTNLOGDATA = 1021,
			ID_BTNCREATELUT = 1020,
			ID_BTNCREATEPEDESTAL = 1019,
			ID_BTNSYNCUSB = 1018,
			ID_GRPINIT = 1033,
			ID_RAWOUTPUT = 1010,
			ID_PAGEOUTPUT = 1005,
			ID_PAGEGRAPH = 1003,
			ID_BOXDISPLAY = 1002,
			ID_WXPANEL1 = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		
		float Waveform[256];
		
		int activePedestal[4*256];
		short unsigned int buffer[1300];
		float LUT[MAX_LUT][4];
		OscScreen *scope;
		
		int chSpikes[CHANNELS];
		int bufferSpikes[BUFFERSIZE];
		int totalReadouts;
	    void UpdateSpikeStats();

        vector<int> hiCmd;
        vector<int> loCmd;
		
		void ReadData();
		void LogData();
		
		void UpdateWaveforms();
		void CreatePedestal(int pedVoltage = -1);
		
		int chOffset;
		
		stdUSB in;
		FILE* logFile;
};

#endif
